unit getUser;

interface

uses Windows, SysUtils, Classes, ComCtrls;

type
  TSessionInfo502 = packed record
    Sesi502_cname: PWideChar;
    Sesi502_username: PWideChar;
    Sesi502_num_opens: DWORD;
    Sesi502_time: DWORD;
    Sesi502_idle_time: DWORD;
    Sesi502_user_flags: DWORD;
    Sesi502_cltype_name: PWideChar;
    Sesi502_transport: PWideChar;
  end;

  TSessionInfo50 = packed record
    Sesi50_cname: PChar;
    Sesi50_username: PChar;
    sesi50_key: Cardinal;
    sesi50_num_conns: Word;
    sesi50_num_opens: Word;
    sesi50_time: Cardinal;
    sesi50_idle_time: Cardinal;
    sesi50_protocol: Byte;
    pad1: Byte;
  end;

  TFileInfo3 = packed record
    fi3_id: DWORD;
    fi3_permissions: DWORD;
    fi3_num_locks: DWORD;
    fi3_pathname: PWChar;
    fi3_username: PWChar;
  end;

  PSessionInfo502 = ^TSessionInfo502;
  TSessionInfo502Array = array[0..512] of TSessionInfo502;
  PSessionInfo502Array = ^TSessionInfo502Array;
  PFileInfo3 = ^TFileInfo3;
  TFileInfo3Array = array[0..512] of TFileInfo3;
  PFileInfo3Array = ^TFileInfo3Array;


var
  NetSessionEnumNT: function(servername,
    UncClientName,
    username: PWChar;
    level: DWORD;
    bufptr: Pointer;
    prefmaxlen: DWORD;
    entriesread,
    totalentries,
    resume_handle: LPDWORD): DWORD; stdcall;

  NetSessionEnum: function(pszServer: PChar;
    sLevel: DWORD;
    pbBuffer: Pointer;
    cbBuffer: DWORD;
    pcEntriesRead,
    pcTotalAvial: Pointer): integer; stdcall;

  NetSessionDelNT: function(ServerName,
    UncClientName,
    username: PWChar): DWORD; stdcall;

  NetSessionDel: function(pszServer: PChar;
    pszClientName: PChar;
    sReserved: SmallInt): DWORD; stdcall;


type
  TFileInfo50 = packed record
    fi50_id: Cardinal;
    fi50_permissions: WORD;
    fi50_num_locks: WORD;
    fi50_pathname: PChar;
    fi50_username: PChar;
    fi50_sharename: PChar;
  end;

procedure GetConnected(var lvSessions: TListView);
function IsNT(var Value: Boolean): Boolean;
procedure CloseSession(indX: Integer; cap: string);
procedure getFilesList(var gt: tListView; UserNameTek: string);
function getFilesExc(UserNameTek: string): boolean;

var
  SessionCloseKey: array[0..512] of SmallInt;
var
  NetFileEnumNT: function(servername,
    basepath,
    username: PWChar;
    level: DWORD;
    bufptr: Pointer;
    prefmaxlen: DWORD;
    entriesread,
    totalentries,
    resume_handle: LPDWORD): DWORD; stdcall;

var
  NetFileEnum: function(pszServer,
    pszBasePath: PChar;
    sLevel: DWORD;
    pbBuffer: Pointer;
    cbBuffer: DWORD;
    pcEntriesRead,
    pcTotalAvail: pointer): integer; stdcall;

var
  NetFileClose: function(ServerName: PWideChar;
    FileId: DWORD): DWORD; stdcall;

var
  NetFileClose2: function(pszServer: PChar;
    ulFileId: LongWord): DWORD; stdcall;

implementation

function CardinalToTimeStr(Value: Cardinal): string;
var
  d, h, m, s: Real;
begin
  d := 0;
  h := 0;
  m := 0;
  s := Value;
  if s > 59 then
  begin
    m := int(s / 60);
    s := s - (m * 60);
  end;
  if m > 59 then
  begin
    h := int(m / 60);
    m := m - (h * 60);
  end;
  if h > 23 then
  begin
    d := int(h / 24);
    h := h - (d * 24);
  end;
  Result := '';
  if (d > 0) then
    Result := Result + floattostr(d) + ' d. ';
  if (h < 9) then
    Result := Result + '0' + floattostr(h) + ':'
  else
    Result := Result + floattostr(h) + ':';
  if (m < 9) then
    Result := Result + '0' + floattostr(m) + ':'
  else
    Result := Result + floattostr(m) + ':';
  if (s < 9) then
    Result := Result + '0' + floattostr(s)
  else
    Result := Result + floattostr(s);
end;

function IsNT(var Value: Boolean): Boolean;
var
  Ver: TOSVersionInfo;
  BRes: Boolean;
begin
  Ver.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  BRes := GetVersionEx(Ver);
  if not BRes then
  begin
    Result := False;
    Exit;
  end
  else
    Result := True;

  case Ver.dwPlatformId of
    VER_PLATFORM_WIN32_NT: Value := True;
    VER_PLATFORM_WIN32_WINDOWS: Value := False;
    VER_PLATFORM_WIN32s: Result := False;
  end;
end;

procedure getFilesList(var gt: tListView; UserNameTek: string);
var
  OS: Boolean;
  FLibHandle: THandle;
  FileInfoNT: PFileInfo3Array;
  FileInfo9x: array[0..512] of TFileInfo50;
  TotalEntries, EntriesReadNT: DWORD;
  EntriesRead, TotalAvial: Word;
  i: integer;
begin
  if not IsNT(OS) then
    Exit;
  gt.Items.Clear;

  if OS then
  begin
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetFileEnumNT := GetProcAddress(FLibHandle, 'NetFileEnum');
    if not Assigned(NetFileEnumNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    FileInfoNT := nil;
    if NetFileEnumNT(nil, nil, nil, 3, @FileInfoNT, DWORD(-1), @entriesreadNT, @totalentries, nil)
      = 0 then
      for i := 0 to EntriesReadNT - 1 do
      begin
        with gt.Items.Add do
          if FileInfoNT^[i].fi3_username = UserNameTek then
          begin
            Caption := FileInfoNT^[i].fi3_pathname;
            if Pos('.', caption) = 0 then
              ImageIndex := 2
            else
              ImageIndex := 1;
            SubItems.Add(string(IntToStr(FileInfoNT^[i].fi3_id)));
          end;
      end;
  end
  else
  begin             //Windows 9x-Me
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetFileEnum := GetProcAddress(FLibHandle, 'NetFileEnum');
    if not Assigned(NetFileEnum) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    if NetFileEnum(nil, nil, 50, @FileInfo9x, SizeOf(FileInfo9x), @EntriesRead, @TotalAvial) = 0
      then
      for i := 0 to EntriesRead - 1 do
      begin
        with gt.Items.Add do
        begin
          if UpperCase(FileInfo9x[i].fi50_username) = UpperCase(UserNameTek) then
            Caption := FileInfo9x[i].fi50_pathname;
          SubItems.Add(string(IntToStr(FileInfo9x[i].fi50_id)));
        end;
      end;
  end;
  FreeLibrary(FLibHandle);
end;

function getFilesExc(UserNameTek: string): boolean;
var
  OS: Boolean;
  FLibHandle: THandle;
  FileInfoNT: PFileInfo3Array;
  FileInfo9x: array[0..512] of TFileInfo50;
  TotalEntries, EntriesReadNT: DWORD;
  EntriesRead, TotalAvial: Word;
  i: integer;
begin
  result := false;
  if not IsNT(OS) then
    Exit;
  result := False;
  if OS then
  begin
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetFileEnumNT := GetProcAddress(FLibHandle, 'NetFileEnum');
    if not Assigned(NetFileEnumNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    FileInfoNT := nil;
    if NetFileEnumNT(nil, nil, nil, 3, @FileInfoNT, DWORD(-1), @entriesreadNT, @totalentries, nil)
      = 0 then
      result := False;
    for i := 0 to EntriesReadNT - 1 do
      if FileInfoNT^[i].fi3_username = UserNameTek then
        result := true;
  end
  else
  begin             //Windows 9x-Me
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetFileEnum := GetProcAddress(FLibHandle, 'NetFileEnum');
    if not Assigned(NetFileEnum) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    result := False;
    if NetFileEnum(nil, nil, 50, @FileInfo9x, SizeOf(FileInfo9x), @EntriesRead, @TotalAvial) = 0
      then
      for i := 0 to EntriesRead - 1 do
        if UpperCase(FileInfo9x[i].fi50_username) = UpperCase(UserNameTek) then
          result := true;
  end;
  FreeLibrary(FLibHandle);
end;

procedure CloseSession(indX: Integer; cap: string);
var
  OS: Boolean;
  FLibHandle: THandle;
  CNameNT: PWideChar;
  CName9x: PAnsiChar;
  Key: SmallInt;
  i: Integer;
begin
  if not IsNT(OS) then
    Halt;

  i := IndX;

  if OS then
  begin
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetSessionDelNT := GetProcAddress(FLibHandle, 'NetSessionDel');
    if not Assigned(NetSessionDelNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;

    CNameNT := PWChar(WideString('\\' + Cap));
    NetSessionDelNT(nil, CNameNT, nil);
  end
  else
  begin
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetSessionDel := GetProcAddress(FLibHandle, 'NetSessionDel');
    if not Assigned(NetSessionDel) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;

    CName9x := PAnsiChar(Cap);
    key := SessionCloseKey[i];
    NetSessionDel(nil, CName9x, Key);
  end;
  FreeLibrary(FLibHandle);
end;

procedure GetConnected(var lvSessions: TListView);
var
  OS: Boolean;
  FLibHandle: THandle;
  SessionInfo50: array[0..512] of TSessionInfo50;
  SessionInfo502: PSessionInfo502Array;
  TotalEntries, EntriesReadNT: DWORD;
  EntriesRead, TotalAvial: Word;
  i: integer;
begin
  lvSessions.Items.Clear;

  if not IsNT(OS) then
    Halt;

  if OS then
  begin             //NT
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetSessionEnumNT := GetProcAddress(FLibHandle, 'NetSessionEnum');
    if not Assigned(NetSessionEnumNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    SessionInfo502 := nil;
    if NetSessionEnumNT(nil, nil, nil, 502, @SessionInfo502, DWORD(-1), @entriesreadNT,
      @totalentries, nil) = 0 then
      for i := 0 to EntriesReadNT - 1 do
      begin
        with lvSessions.Items.Add do
        begin
          Caption := string(SessionInfo502^[i].sesi502_cname);
          SubItems.Add(SessionInfo502^[i].sesi502_username);
          SubItems.Add(IntToStr(SessionInfo502^[i].sesi502_num_opens));
          SubItems.Add(CardinalToTimeStr(SessionInfo502^[i].Sesi502_Time));
          SubItems.Add(CardinalToTimeStr(SessionInfo502^[i].sesi502_idle_time));
          if SessionInfo502^[i].sesi502_num_opens = 0 then
            imageIndex := 0
          else
            imageIndex := 3;
        end;
      end;
  end
  else
  begin             //Windows 9x-Me
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then
      Exit;
    @NetSessionEnum := GetProcAddress(FLibHandle, 'NetSessionEnum');
    if not Assigned(NetSessionEnum) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    if NetSessionEnum(nil, 50, @SessionInfo50, SizeOf(SessionInfo50), @EntriesRead, @TotalAvial) = 0
      then
      for i := 0 to EntriesRead - 1 do
      begin
        with lvSessions.Items.Add do
        begin
          Caption := string(SessionInfo50[i].Sesi50_cname);
          SubItems.Add(SessionInfo50[i].Sesi50_username);
          SubItems.Add(IntToStr(SessionInfo50[i].sesi50_num_opens));
          SubItems.Add(CardinalToTimeStr(SessionInfo50[i].Sesi50_Time));
          SubItems.Add(CardinalToTimeStr(SessionInfo50[i].sesi50_idle_time));
          SessionCloseKey[i] := SessionInfo50[i].sesi50_key;
        end;
      end;
  end;
  FreeLibrary(FLibHandle);
end;

end.

 